#include "backend.h"
#include "testobject.h"
#include "qdebug.h"

Backend::Backend(QObject *parent) : QObject(parent)
{
    for (int i = 0; i < 1000; i++) {
        rawDesc[i] = QString("item number ") + QString::number(i);
    }
\
    for (int i = 0; i < 1000; i++) {
        rawData[i] = i;
    }



}

QString Backend::getDesc(int id)
{
    return rawDesc[id];
}

int Backend::getData(int id)
{
    return rawData[id];
}

void Backend::dataChanged(int id, int type, QString modified)
{
    qDebug() << "data has been changed " << id << " " << type << " " << modified;

    if (type == 0) {
        rawDesc[id] = modified;
        qDebug() << "rawDesc "  << id << " is now " << rawDesc[id];
    } else if (type == 1) {
        rawData[id] = modified.toInt();
        qDebug() << "rawData "  << id << " is now " << rawData[id];
    }
}

void Backend::setEngine(QQmlApplicationEngine *engine)
{
    m_engine = engine;
}

void Backend::setModel()
{
    QList<QObject *> dataList;

    for (int i = 0; i < 1000; i++) {
        dataList.append(new TestObject(i, "6", "internal_test"));
    }

    m_engine->rootContext()->setContextProperty("myModel", QVariant::fromValue(dataList));
}
