#ifndef BACKEND_H
#define BACKEND_H

#include <QObject>
#include <QQmlApplicationEngine>
#include <QQmlContext>


enum dataType {
    NAME,
    DATA
};


class Backend : public QObject
{
    Q_OBJECT
public:
    explicit Backend(QObject *parent = nullptr);

    QString getDesc(int id);
    int getData(int id);

    QList<QObject*> getModel();

    void setEngine(QQmlApplicationEngine *engine);

    void setModel();


public slots:
    void dataChanged(int id, int type, QString modified);

private:
    QString rawDesc[1000];
    int rawData[1000];
    QQmlApplicationEngine *m_engine;
};

#endif // BACKEND_H
