#include <QGuiApplication>

#include <qqmlengine.h>
#include <qqmlcontext.h>
#include <qqml.h>
#include <QtQuick/qquickitem.h>
#include <QtQuick/qquickview.h>

#include <QFile>
#include <QDataStream>
#include "testobject.h"
#include "backend.h"

#include <QQmlApplicationEngine>
#include <QQmlContext>

int main(int argc, char *argv[])
{
    QGuiApplication::setAttribute(Qt::AA_EnableHighDpiScaling);
    QGuiApplication app(argc, argv);

    Backend backend;

    QList<QObject *> dataList;

    for (int i = 0; i < 1000; i++) {
        dataList.append(new TestObject(i, backend.getDesc(i), QString::number(backend.getData(i))));
    }

    QList<QObject *> dataList2;

    for (int i = 0; i < 500; i++) {
        dataList2.append(new TestObject(i, "test", QString::number(i)));
    }


//    QQuickView view;
//    view.setResizeMode(QQuickView::SizeRootObjectToView);
//    view.rootContext()->setContextProperty("backend", &backend);
//    view.setInitialProperties({{ "model", QVariant::fromValue(dataList)}});

//    view.setSource(QUrl("qrc:main.qml"));
//    view.show();

    static QQmlApplicationEngine engine;
    const QUrl url(QStringLiteral("qrc:/main.qml"));
//    QObject::connect(&engine, &QQmlApplicationEngine::objectCreated,
//                     &app, [url](QObject *obj, const QUrl &objUrl) {
//        if (!obj && url == objUrl)
//            QCoreApplication::exit(-1);
//    }, Qt::QueuedConnection);


    engine.rootContext()->setContextProperty("backend", &backend);
    engine.rootContext()->setContextProperty("myModel", QVariant::fromValue(dataList));
    engine.rootContext()->setContextProperty("myModel2", QVariant::fromValue(dataList2));
    engine.load(url);

    backend.setEngine(&engine);
    backend.setModel();

//    int i = 0;
//    qDeleteAll(dataList.begin(), dataList.end());
//    dataList.clear();
//    while (i < 10) {
//        dataList.append(new TestObject(i, "test", QString::number(i)));
//        i++;
//    }

//    engine.rootContext()->setContextProperty("myModel", QVariant::fromValue(dataList));

    return app.exec();
}


