//import QtQuick 2.0
//import QtQuick.Window 2.12
//import QtQuick.Controls 2.15

import QtQuick 2.12
import QtQuick.Window 2.12
import QtQuick.Layouts 1.12
import QtQuick.Controls 1.4
import QtQuick.Controls 2.12
import QtQml 2.12

Window {

    width: 400
    height: 200
    color: "blue"
    visible: true
    ListView {
        id: listview
        header: testHeader
        cacheBuffer: 900000

        highlight: highlight
        interactive: true
        width: 350; height: 200
        model: myModel

        delegate: Rectangle {


            height: 50
            width: 300
            border.color: "black"
            TextField {
                height: 50
                width: 150
                text: model.name
                onEditingFinished: backend.dataChanged(model.id, 0, text)
            }

            TextField {
                x: 150
                height: 50
                width: 150
                text: model.data
                onEditingFinished: backend.dataChanged(model.id, 1, text)
            }


        }

        ScrollBar.vertical: ScrollBar {
            parent: listview.parent
            anchors.top: listview.top
            anchors.right: listview.right
            anchors.bottom: listview.bottom
            active: true
        }

        Component {
            id: testHeader
            Rectangle {
                width: parent.width
                height: 50
                Text {
                    id: name
                    text: qsTr("text")
                }
            }
        }



    }
    Button {
        x: 350
        width: 50
        height: 50

        onPressed: {
            listview.model = myModel2
        }
    }

    Button {
        x: 350
        y: 50
        width: 50
        height: 50

        onPressed: {
            listview.model = myModel
        }
    }

    Component {
        id: highlight
        Rectangle {
            width: 180; height: 40
            color: "lightsteelblue"; radius: 5
            y: list.currentItem.y
            Behavior on y {
                SpringAnimation {
                    spring: 3
                    damping: 0.2
                }
            }
        }
    }
}


