#include <QDebug>
#include "testobject.h"

TestObject::TestObject(QObject *parent)
    : QObject(parent)
{
}

TestObject::TestObject(const int &id, const QString &name, const QString &data, QObject *parent)
    : QObject(parent)
{
    m_id = id;
    m_name = name;
    m_data = data;
}

int TestObject::id() const
{
    return m_id;
}

void TestObject::setId(const int &id)
{
    if (id != m_id) {
        m_id = id;
        emit idChanged();
    }
    qDebug() << "id was changed:" << m_id;
}

QString TestObject::name() const
{
    return m_name;
}

void TestObject::setName(const QString &name)
{
    if (name != m_name) {
        m_name = name;
        emit nameChanged();
    }
    qDebug() << "name was changed:" << m_name;
}

QString TestObject::data() const
{
    return m_data;
}

void TestObject::setData(const QString &data)
{
    if (data != m_data) {
        m_data = data;
        emit dataChanged();
    }
    qDebug() << "data was changed:" << m_data;
}


