#ifndef TESTOBJECT_H
#define TESTOBJECT_H

#include <QObject>

class TestObject : public QObject
{
    Q_OBJECT

    Q_PROPERTY(int id READ id WRITE setId NOTIFY idChanged CONSTANT)
    Q_PROPERTY(QString name READ name WRITE setName NOTIFY nameChanged CONSTANT)
    Q_PROPERTY(QString data READ data WRITE setData NOTIFY dataChanged CONSTANT)
//![0]

public:
    TestObject(QObject *parent=0);
    TestObject(const int &id, const QString &name, const QString &data, QObject *parent=0);

    int id() const;
    void setId(const int &id);

    QString name() const;
    void setName(const QString &name);

    QString data() const;
    void setData(const QString &data);



signals:
    void idChanged();
    void nameChanged();
    void dataChanged();


private:
    int m_id;
    QString m_name;
    QString m_data;


};

#endif // TESTOBJECT_H
